//Un niveau standard : contient des liens et des noeuds !
package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;
	import flash.events.MouseEvent;//Interaction utilisateur//souris
	import flash.filters.BitmapFilter;
	import flash.filters.GlowFilter;

	public class Land extends Sprite
	{
		public var All_Noeuds:Array;
		public var All_Liens:Array;

		public var StartNode:Noeud;
		public var EndNode:Noeud;

		private const FlashWidth:int = 640;
		private const FlashHeight:int = 480;

		private static const Filtre_Noeuds_Extremes:Array=new Array(new GlowFilter(0x0000FF, 0.8,16,16,4),new GlowFilter(0x0000FF, 0.8,8,8,4,1,true))

		public function Land()
		{
// 			var Niv_String:String="140,240|500,240:0,1,320,440|0,1,320,40|0,1,320,240";
// 			var Niv_String:String= "98,370|419,367|266,211|256,49:3,2,261,130|2,0,232,361|2,1,289,330|2,0,182,291|2,1,342,289";
			var Niv_String:String= "34,289|174,282|286,181|286,221|280,280|277,325|277,353|415,320|531,279|411,200|607,276:0,1,104,285|1,2,230,231|1,3,230,252|1,4,227,281|1,5,225,303|1,6,225,317|6,7,347,316|5,7,347,302|7,8,473,299|4,8,406,279|3,9,313,211|2,9,313,191|9,8,471,240|8,10,569,277"
			var Composants:Array;
			var Part:Array=Niv_String.split(":");
			var strNoeuds_Array:Array=Part[0].split("|");
			var strArc_Array:Array=Part[1].split("|");
			var Noeuds:Array=new Array();
			var Liens:Array=new Array();
			for each(var Node:String in strNoeuds_Array)
			{
				Composants=Node.split(",");
				Noeuds.push(Composants);
			}
			for each(var Arete:String in strArc_Array)
			{
				Composants=Arete.split(",");
				Liens.push(Composants);
			}

			CreerNiveau(Noeuds,Liens,FlashWidth,FlashHeight);
		}

		private function CreerNiveau(Noeuds:Array,Liens:Array,Largeur:int=0,Hauteur:int=0):void
		{
			var Node:Noeud;
			var Arete:Arc;

			All_Noeuds = new Array();
			All_Liens = new Array();
			for each(var Arr_Noeud:Array in Noeuds)
				All_Noeuds.push(new Noeud(this,Arr_Noeud[0],Arr_Noeud[1]));

			StartNode=All_Noeuds[0];
			EndNode=All_Noeuds[All_Noeuds.length-1];
			StartNode.filters=Filtre_Noeuds_Extremes;
			EndNode.filters=Filtre_Noeuds_Extremes;

			for each(var Arr_Lien:Array in Liens)
			{
				Arete=new Arc(this,All_Noeuds[Arr_Lien[0]],All_Noeuds[Arr_Lien[1]],new Point(Arr_Lien[2],Arr_Lien[3]));
				All_Noeuds[Arr_Lien[0]].AjouterLien(Arete);
				All_Noeuds[Arr_Lien[1]].AjouterLien(Arete);
				All_Liens.push(Arete);
			}

			this.graphics.beginFill(0xFFFFFF);
			this.graphics.drawRect(0,0, Largeur, Hauteur);
		}
	}
}